/* $Id */

/* IO߰Ē` */

struct _SCI {

    union {
        uchar BYTE;
        struct {
            uchar CA      : 1;
            uchar CHR     : 1;
            uchar PER     : 1;
            uchar OE      : 1;
            uchar STOP    : 1;
            uchar MP      : 1;
            uchar CKS     : 2;
        } BIT;
    } SMR;

    uchar BRR;

    union {
        uchar BYTE;
        struct {
            uchar TIE     : 1;
            uchar RIE     : 1;
            uchar TE      : 1;
            uchar RE      : 1;
            uchar MPIE    : 1;
            uchar TEIE    : 1;
            uchar CKE     : 2;
        } BIT;
    } SCR;

    uchar TDR;

    union {
        uchar BYTE;
        struct {
            uchar TDRE    : 1;
            uchar RDRF    : 1;
            uchar ORER    : 1;
            uchar FER     : 1;
            uchar PER     : 1;
            uchar TEND    : 1;
            uchar MPB     : 1;
            uchar MPBT    : 1;
        } BIT;
    } SSR;

    uchar RDR;

    char WK[2];

};

struct _MTU {

    union {
        uchar BYTE;
        struct {
            uchar CST4    : 1;
            uchar CST3    : 1;
            uchar         : 3;
            uchar CST2    : 1;
            uchar CST1    : 1;
            uchar CST0    : 1;
        } BIT;
    } TSTR;

    union {
        uchar BYTE;
        struct {
            uchar SYNC4   : 1;
            uchar SYNC3   : 1;
            uchar         : 3;
            uchar SYNC2   : 1;
            uchar SYNC1   : 1;
            uchar SYNC0   : 1;
        } BIT;
    } TSYR;

};

struct _MTU0 {

    union {
        uchar BYTE;
        struct {
            uchar CCLR    : 3;
            uchar CKEG    : 2;
            uchar TPSC    : 3;
        } BIT;
    } TCR;

    union {
        uchar BYTE;
        struct {
            uchar         : 2;
            uchar BFB     : 1;
            uchar BFA     : 1;
            uchar MD      : 4;
        } BIT;
    } TMDR;

    union {
        ushort WORD;
        struct {
            uchar H;
            uchar L;
        } BYTE;
        struct {
            uchar IOB     : 4;
            uchar IOA     : 4;
            uchar IOD     : 4;
            uchar IOC     : 4;
        } BIT;
    } TIOR;

    union {
        uchar BYTE;
        struct {
            uchar TTGE    : 1;
            uchar         : 2;
            uchar TCIEV   : 1;
            uchar TGIED   : 1;
            uchar TGIEC   : 1;
            uchar TGIEB   : 1;
            uchar TGIEA   : 1;
        } BIT;
    } TIER;

    union {
        uchar BYTE;
        struct {
            uchar         : 3;
            uchar TCFV    : 1;
            uchar TGFD    : 1;
            uchar TGFC    : 1;
            uchar TGFB    : 1;
            uchar TGFA    : 1;
        } BIT;
    } TSR;

    ushort TCNT;

    ushort TGRA;

    ushort TGRB;

    ushort TGRC;

    ushort TGRD;

};

struct _MTU1 {

    union {
        uchar BYTE;
        struct {
            uchar         : 1;
            uchar CCLR    : 2;
            uchar CKEG    : 2;
            uchar TPSC    : 3;
        } BIT;
    } TCR;

    union {
        uchar BYTE;
        struct {
            uchar         : 4;
            uchar MD      : 4;
        } BIT;
    } TMDR;

    union {
        uchar BYTE;
        struct {
            uchar IOB     : 4;
            uchar IOA     : 4;
        } BIT;
    } TIOR;

    char WK;

    union {
        uchar BYTE;
        struct {
            uchar TTGE    : 1;
            uchar         : 1;
            uchar TCIEU   : 1;
            uchar TCIEV   : 1;
            uchar         : 2;
            uchar TGIEB   : 1;
            uchar TGIEA   : 1;
        } BIT;
    } TIER;

    union {
        uchar BYTE;
        struct {
            uchar TCFD    : 1;
            uchar         : 1;
            uchar TCFU    : 1;
            uchar TCFV    : 1;
            uchar         : 2;
            uchar TGFB    : 1;
            uchar TGFA    : 1;
        } BIT;
    } TSR;

    ushort TCNT;

    ushort TGRA;

    ushort TGRB;

};

struct _MTU3 {

    union {
        uchar BYTE;
        struct {
            uchar CCLR    : 3;
            uchar CKEG    : 2;
            uchar TPSC    : 3;
        } BIT;
    } TCR;

    char WK1;

    union {
        uchar BYTE;
        struct {
            uchar         : 2;
            uchar BFB     : 1;
            uchar BFA     : 1;
            uchar MD      : 4;
        } BIT;
    } TMDR;

    char WK2;

    union {
        ushort WORD;
        struct {
            uchar H;
            uchar L;
        } BYTE;
        struct {
            uchar IOB     : 4;
            uchar IOA     : 4;
            uchar IOD     : 4;
            uchar IOC     : 4;
        } BIT;
    } TIOR;

    char WK3[2];

    union {
        uchar BYTE;
        struct {
            uchar TTGE    : 1;
            uchar         : 2;
            uchar TCIEV   : 1;
            uchar TGIED   : 1;
            uchar TGIEC   : 1;
            uchar TGIEB   : 1;
            uchar TGIEA   : 1;
        } BIT;
    } TIER;

    char WK4[7];

    ushort TCNT;

    char WK5[6];

    ushort TGRA;

    ushort TGRB;

    char WK6[8];

    ushort TGRC;

    ushort TGRD;

    char WK7[4];

    union {
        uchar BYTE;
        struct {
            uchar TCFD    : 1;
            uchar         : 2;
            uchar TCFV    : 1;
            uchar TGFD    : 1;
            uchar TGFC    : 1;
            uchar TGFB    : 1;
            uchar TGFA    : 1;
        } BIT;
    } TSR;

};

struct _MTU4 {

    char WK1;

    union {
        uchar BYTE;
        struct {
            uchar CCLR    : 3;
            uchar CKEG    : 2;
            uchar TPSC    : 3;
        } BIT;
    } TCR;

    char WK2;

    union {
        uchar BYTE;
        struct {
            uchar         : 2;
            uchar BFB     : 1;
            uchar BFA     : 1;
            uchar MD      : 4;
        } BIT;
    } TMDR;

    char WK3[2];

    union {
        ushort WORD;
        struct {
            uchar H;
            uchar L;
        } BYTE;
        struct {
            uchar IOB     : 4;
            uchar IOA     : 4;
            uchar IOD     : 4;
            uchar IOC     : 4;
        } BIT;
    } TIOR;

    char WK4;

    union {
        uchar BYTE;
        struct {
            uchar TTGE    : 1;
            uchar         : 2;
            uchar TCIEV   : 1;
            uchar TGIED   : 1;
            uchar TGIEC   : 1;
            uchar TGIEB   : 1;
            uchar TGIEA   : 1;
        } BIT;
    } TIER;

    char WK5[8];

    ushort TCNT;

    char WK6[8];

    ushort TGRA;

    ushort TGRB;

    char WK7[8];

    ushort TGRC;

    ushort TGRD;

    char WK8;

    union {
        uchar BYTE;
        struct {
            uchar TCFD    : 1;
            uchar         : 2;
            uchar TCFV    : 1;
            uchar TGFD    : 1;
            uchar TGFC    : 1;
            uchar TGFB    : 1;
            uchar TGFA    : 1;
        } BIT;
    } TSR;

};

struct _PWM {

    union {
        uchar BYTE;
        struct {
            uchar CCLR    : 3;
            uchar CKEG    : 2;
            uchar TPSC    : 3;
        } BIT;
    } TCR3;

    union {
        uchar BYTE;
        struct {
            uchar CCLR    : 3;
            uchar CKEG    : 2;
            uchar TPSC    : 3;
        } BIT;
    } TCR4;

    union {
        uchar BYTE;
        struct {
            uchar         : 2;
            uchar BFB     : 1;
            uchar BFA     : 1;
            uchar MD      : 4;
        } BIT;
    } TMDR3;

    union {
        uchar BYTE;
        struct {
            uchar         : 2;
            uchar BFB     : 1;
            uchar BFA     : 1;
            uchar MD      : 4;
        } BIT;
    } TMDR4;

    union {
        ushort WORD;
        struct {
            uchar H;
            uchar L;
        } BYTE;
        struct {
            uchar IOB     : 4;
            uchar IOA     : 4;
            uchar IOD     : 4;
            uchar IOC     : 4;
        } BIT;
    } TIOR3;

    union {
        ushort WORD;
        struct {
            uchar H;
            uchar L;
        } BYTE;
        struct {
            uchar IOB     : 4;
            uchar IOA     : 4;
            uchar IOD     : 4;
            uchar IOC     : 4;
        } BIT;
    } TIOR4;

    union {
        uchar BYTE;
        struct {
            uchar TTGE    : 1;
            uchar         : 2;
            uchar TCIEV   : 1;
            uchar TGIED   : 1;
            uchar TGIEC   : 1;
            uchar TGIEB   : 1;
            uchar TGIEA   : 1;
        } BIT;
    } TIER3;

    union {
        uchar BYTE;
        struct {
            uchar TTGE    : 1;
            uchar         : 2;
            uchar TCIEV   : 1;
            uchar TGIED   : 1;
            uchar TGIEC   : 1;
            uchar TGIEB   : 1;
            uchar TGIEA   : 1;
        } BIT;
    } TIER4;

    union {
        uchar BYTE;
        struct {
            uchar         : 2;
            uchar OE4D    : 1;
            uchar OE4C    : 1;
            uchar OE3D    : 1;
            uchar OE4B    : 1;
            uchar OE4A    : 1;
            uchar OE3B    : 1;
        } BIT;
    } TOER;

    union {
        uchar BYTE;
        struct {
            uchar         : 1;
            uchar PSYE    : 1;
            uchar         : 4;
            uchar OLSN    : 1;
            uchar OLSP    : 1;
        } BIT;
    } TOCR;

    char WK1;

    union {
        uchar BYTE;
        struct {
            uchar         : 1;
            uchar BDC     : 1;
            uchar N       : 1;
            uchar P       : 1;
            uchar FB      : 1;
            uchar WF      : 1;
            uchar VF      : 1;
            uchar UF      : 1;
        } BIT;
    } TGCR;

    char WK2[2];

    ushort TCNT3;

    ushort TCNT4;

    ushort TCDR;

    ushort TDDR;

    ushort TGR3A;

    ushort TGR3B;

    ushort TGR4A;

    ushort TGR4B;

    ushort TCNTS;

    ushort TCBR;

    ushort TGR3C;

    ushort TGR3D;

    ushort TGR4C;

    ushort TGR4D;

    union {
        uchar BYTE;
        struct {
            uchar TCFD    : 1;
            uchar         : 2;
            uchar TCFV    : 1;
            uchar TGFD    : 1;
            uchar TGFC    : 1;
            uchar TGFB    : 1;
            uchar TGFA    : 1;
        } BIT;
    } TSR3;

    union {
        uchar BYTE;
        struct {
            uchar TCFD    : 1;
            uchar         : 2;
            uchar TCFV    : 1;
            uchar TGFD    : 1;
            uchar TGFC    : 1;
            uchar TGFB    : 1;
            uchar TGFA    : 1;
        } BIT;
    } TSR4;

};

struct _INTC {

    union {
        ushort WORD;
        struct {
            uchar UU      : 4;
            uchar UL      : 4;
            uchar LU      : 4;
            uchar LL      : 4;
        } BIT;
    } IPRA;

    union {
        ushort WORD;
        struct {
            uchar UU      : 4;
            uchar UL      : 4;
            uchar LU      : 4;
            uchar LL      : 4;
        } BIT;
    } IPRB;

    union {
        ushort WORD;
        struct {
            uchar UU      : 4;
            uchar UL      : 4;
            uchar LU      : 4;
            uchar LL      : 4;
        } BIT;
    } IPRC;

    union {
        ushort WORD;
        struct {
            uchar UU      : 4;
            uchar UL      : 4;
            uchar LU      : 4;
            uchar LL      : 4;
        } BIT;
    } IPRD;

    union {
        ushort WORD;
        struct {
            uchar UU      : 4;
            uchar UL      : 4;
            uchar LU      : 4;
            uchar LL      : 4;
        } BIT;
    } IPRE;

    union {
        ushort WORD;
        struct {
            uchar UU      : 4;
            uchar UL      : 4;
            uchar LU      : 4;
            uchar LL      : 4;
        } BIT;
    } IPRF;

    union {
        ushort WORD;
        struct {
            uchar UU      : 4;
            uchar UL      : 4;
            uchar LU      : 4;
            uchar LL      : 4;
        } BIT;
    } IPRG;

    union {
        ushort WORD;
        struct {
            uchar UU      : 4;
            uchar UL      : 4;
        } BIT;
    } IPRH;

    union {
        ushort WORD;
        struct {
            uchar NMIL    : 1;
            uchar         : 6;
            uchar NMIE    : 1;
            uchar IRQ0S   : 1;
            uchar IRQ1S   : 1;
            uchar IRQ2S   : 1;
            uchar IRQ3S   : 1;
            uchar IRQ4S   : 1;
            uchar IRQ5S   : 1;
            uchar IRQ6S   : 1;
            uchar IRQ7S   : 1;
        } BIT;
    } ICR;

    union {
        ushort WORD;
        struct {
            uchar         : 8;
            uchar IRQ0F   : 1;
            uchar IRQ1F   : 1;
            uchar IRQ2F   : 1;
            uchar IRQ3F   : 1;
            uchar IRQ4F   : 1;
            uchar IRQ5F   : 1;
            uchar IRQ6F   : 1;
            uchar IRQ7F   : 1;
        } BIT;
    } ISR;

};

struct _PA {

    union {
        uint LONG;
        struct {
            ushort H;
            ushort L;
        } WORD;
        struct {
            char WK;
            uchar HL;
            uchar LH;
            uchar LL;
        } BYTE;
        struct {
            uchar         : 8;
            uchar B23     : 1;
            uchar B22     : 1;
            uchar B21     : 1;
            uchar B20     : 1;
            uchar B19     : 1;
            uchar B18     : 1;
            uchar B17     : 1;
            uchar B16     : 1;
            uchar B15     : 1;
            uchar B14     : 1;
            uchar B13     : 1;
            uchar B12     : 1;
            uchar B11     : 1;
            uchar B10     : 1;
            uchar B9      : 1;
            uchar B8      : 1;
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } DR;

};

struct _PB {

    union {
        ushort WORD;
        struct {
            uchar H;
            uchar L;
        } BYTE;
        struct {
            uchar         : 6;
            uchar B9      : 1;
            uchar B8      : 1;
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } DR;

};

struct _PC {

    union {
        ushort WORD;
        struct {
            uchar H;
            uchar L;
        } BYTE;
        struct {
            uchar B15     : 1;
            uchar B14     : 1;
            uchar B13     : 1;
            uchar B12     : 1;
            uchar B11     : 1;
            uchar B10     : 1;
            uchar B9      : 1;
            uchar B8      : 1;
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } DR;

};

struct _PD {

    union {
        uint LONG;
        struct {
            ushort H;
            ushort L;
        } WORD;
        struct {
            uchar HH;
            uchar HL;
            uchar LH;
            uchar LL;
        } BYTE;
        struct {
            uchar B31     : 1;
            uchar B30     : 1;
            uchar B29     : 1;
            uchar B28     : 1;
            uchar B27     : 1;
            uchar B26     : 1;
            uchar B25     : 1;
            uchar B24     : 1;
            uchar B23     : 1;
            uchar B22     : 1;
            uchar B21     : 1;
            uchar B20     : 1;
            uchar B19     : 1;
            uchar B18     : 1;
            uchar B17     : 1;
            uchar B16     : 1;
            uchar B15     : 1;
            uchar B14     : 1;
            uchar B13     : 1;
            uchar B12     : 1;
            uchar B11     : 1;
            uchar B10     : 1;
            uchar B9      : 1;
            uchar B8      : 1;
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } DR;

};

struct _PF {

    union {
        uchar BYTE;
        struct {
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } DR;

};

struct _PFC {

    union {
        ushort WORD;
        struct {
            uchar         : 8;
            uchar B23     : 1;
            uchar B22     : 1;
            uchar B21     : 1;
            uchar B20     : 1;
            uchar B19     : 1;
            uchar B18     : 1;
            uchar B17     : 1;
            uchar B16     : 1;
        } BIT;
    } PAIORH;

    union {
        ushort WORD;
        struct {
            uchar B15     : 1;
            uchar B14     : 1;
            uchar B13     : 1;
            uchar B12     : 1;
            uchar B11     : 1;
            uchar B10     : 1;
            uchar B9      : 1;
            uchar B8      : 1;
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } PAIORL;

    union {
        ushort WORD;
        struct {
            uchar         : 1;
            uchar MD23    : 1;
            uchar         : 1;
            uchar MD22    : 1;
            uchar         : 1;
            uchar MD21    : 1;
            uchar         : 1;
            uchar MD20    : 1;
            uchar MD19    : 2;
            uchar MD18    : 2;
            uchar         : 1;
            uchar MD17    : 1;
            uchar         : 1;
            uchar MD16    : 1;
        } BIT;
    } PACRH;

    char WK1[2];

    union {
        ushort WORD;
        struct {
            uchar         : 1;
            uchar MD15    : 1;
            uchar         : 1;
            uchar MD14    : 1;
            uchar         : 1;
            uchar MD13    : 1;
            uchar         : 1;
            uchar MD12    : 1;
            uchar         : 1;
            uchar MD11    : 1;
            uchar         : 1;
            uchar MD10    : 1;
            uchar MD9     : 2;
            uchar MD8     : 2;
        } BIT;
    } PACRL1;

    union {
        ushort WORD;
        struct {
            uchar MD7     : 2;
            uchar MD6     : 2;
            uchar MD5     : 2;
            uchar         : 1;
            uchar MD4     : 1;
            uchar         : 1;
            uchar MD3     : 1;
            uchar MD2     : 2;
            uchar         : 1;
            uchar MD1     : 1;
            uchar         : 1;
            uchar MD0     : 1;
        } BIT;
    } PACRL2;

    char WK2[4];

    union {
        ushort WORD;
        struct {
            uchar         : 6;
            uchar B9      : 1;
            uchar B8      : 1;
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } PBIOR;

    union {
        ushort WORD;
        struct {
            uchar B15     : 1;
            uchar B14     : 1;
            uchar B13     : 1;
            uchar B12     : 1;
            uchar B11     : 1;
            uchar B10     : 1;
            uchar B9      : 1;
            uchar B8      : 1;
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } PCIOR;

    union {
        ushort WORD;
        struct {
            uchar         : 8;
            uchar         : 4;
            uchar MD9     : 2;
            uchar MD8     : 2;
        } BIT;
    } PBCR1;

    union {
        ushort WORD;
        struct {
            uchar MD7     : 2;
            uchar MD6     : 2;
            uchar MD5     : 2;
            uchar MD4     : 2;
            uchar MD3     : 2;
            uchar MD2     : 2;
            uchar         : 1;
            uchar MD1     : 1;
            uchar         : 1;
            uchar MD0     : 1;
        } BIT;
    } PBCR2;

    union {
        ushort WORD;
        struct {
            uchar MD15    : 1;
            uchar MD14    : 1;
            uchar MD13    : 1;
            uchar MD12    : 1;
            uchar MD11    : 1;
            uchar MD10    : 1;
            uchar MD9     : 1;
            uchar MD8     : 1;
            uchar MD7     : 1;
            uchar MD6     : 1;
            uchar MD5     : 1;
            uchar MD4     : 1;
            uchar MD3     : 1;
            uchar MD2     : 1;
            uchar MD1     : 1;
            uchar MD0     : 1;
        } BIT;
    } PCCR;

    char WK4[6];

    union {
        ushort WORD;
        struct {
            uchar B31     : 1;
            uchar B30     : 1;
            uchar B29     : 1;
            uchar B28     : 1;
            uchar B27     : 1;
            uchar B26     : 1;
            uchar B25     : 1;
            uchar B24     : 1;
            uchar B23     : 1;
            uchar B22     : 1;
            uchar B21     : 1;
            uchar B20     : 1;
            uchar B19     : 1;
            uchar B18     : 1;
            uchar B17     : 1;
            uchar B16     : 1;
        } BIT;
    } PDIORH;

    union {
        ushort WORD;
        struct {
            uchar B15     : 1;
            uchar B14     : 1;
            uchar B13     : 1;
            uchar B12     : 1;
            uchar B11     : 1;
            uchar B10     : 1;
            uchar B9      : 1;
            uchar B8      : 1;
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } PDIORL;

    union {
        ushort WORD;
        struct {
            uchar MD31    : 2;
            uchar MD30    : 2;
            uchar MD29    : 2;
            uchar MD28    : 2;
            uchar MD27    : 2;
            uchar MD26    : 2;
            uchar MD25    : 2;
            uchar MD24    : 2;
        } BIT;
    } PDCRH1;

    union {
        ushort WORD;
        struct {
            uchar MD23    : 2;
            uchar MD22    : 2;
            uchar MD21    : 2;
            uchar MD20    : 2;
            uchar MD19    : 2;
            uchar MD18    : 2;
            uchar MD17    : 2;
            uchar MD16    : 2;
        } BIT;
    } PDCRH2;

    union {
        ushort WORD;
        struct {
            uchar MD15    : 1;
            uchar MD14    : 1;
            uchar MD13    : 1;
            uchar MD12    : 1;
            uchar MD11    : 1;
            uchar MD10    : 1;
            uchar MD9     : 1;
            uchar MD8     : 1;
            uchar MD7     : 1;
            uchar MD6     : 1;
            uchar MD5     : 1;
            uchar MD4     : 1;
            uchar MD3     : 1;
            uchar MD2     : 1;
            uchar MD1     : 1;
            uchar MD0     : 1;
        } BIT;
    } PDCRL;

    char WK5[6];

    union {
        ushort WORD;
        struct {
            uchar B15     : 1;
            uchar B14     : 1;
            uchar B13     : 1;
            uchar B12     : 1;
            uchar B11     : 1;
            uchar B10     : 1;
            uchar B9      : 1;
            uchar B8      : 1;
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } PEIOR;

    char WK6[2];

    union {
        ushort WORD;
        struct {
            uchar MD15    : 2;
            uchar MD14    : 2;
            uchar MD13    : 2;
            uchar         : 1;
            uchar MD12    : 1;
            uchar         : 1;
            uchar MD11    : 1;
            uchar         : 1;
            uchar MD10    : 1;
            uchar         : 1;
            uchar MD9     : 1;
            uchar         : 1;
            uchar MD8     : 1;
        } BIT;
    } PECR1;

    union {
        ushort WORD;
        struct {
            uchar         : 1;
            uchar MD7     : 1;
            uchar         : 1;
            uchar MD6     : 1;
            uchar         : 1;
            uchar MD5     : 1;
            uchar         : 1;
            uchar MD4     : 1;
            uchar MD3     : 2;
            uchar MD2     : 2;
            uchar MD1     : 2;
            uchar MD0     : 2;
        } BIT;
    } PECR2;

    char WK7[12];

    union {
        ushort WORD;
        struct {
            uchar         : 8;
            uchar         : 4;
            uchar IRQMD32 : 2;
            uchar IRQMD10 : 2;
        } BIT;
    } IFCR;

};

struct _CMT {

    union {
        ushort WORD;
        struct {
            uchar         : 8;
            uchar         : 6;
            uchar STR1    : 1;
            uchar STR0    : 1;
        } BIT;
    } CMSTR;

};

struct _CMT0 {

    union {
        ushort WORD;
        struct {
            uchar         : 8;
            uchar CMF     : 1;
            uchar CMIE    : 1;
            uchar         : 4;
            uchar CKS     : 2;
        } BIT;
    } CMCSR;

    ushort CMCNT;

    ushort CMCOR;

};

struct _AD {

    union {
        uchar BYTE;
        struct {
            uchar ADF     : 1;
            uchar ADIE    : 1;
            uchar ADST    : 1;
            uchar CKS     : 1;
            uchar GRP     : 1;
            uchar CH      : 3;
        } BIT;
    } CSR;

    union {
        uchar BYTE;
        struct {
            uchar         : 1;
            uchar PWR     : 1;
            uchar TRGS    : 2;
            uchar SCAN    : 1;
            uchar DSMP    : 1;
            uchar BUFE    : 2;
        } BIT;
    } CR;

    char WK[14];

    union {
        ushort WORD;
        uchar BYTE;
    } DRA;

    union {
        ushort WORD;
        uchar BYTE;
    } DRB;

    union {
        ushort WORD;
        uchar BYTE;
    } DRC;

    union {
        ushort WORD;
        uchar BYTE;
    } DRD;

    union {
        ushort WORD;
        uchar BYTE;
    } DRE;

    union {
        ushort WORD;
        uchar BYTE;
    } DRF;

    union {
        ushort WORD;
        uchar BYTE;
    } DRG;

    union {
        ushort WORD;
        uchar BYTE;
    } DRH;

};

struct _ADA {

    union {
        ushort WORD;
        uchar BYTE;
    } DRA0;

    union {
        ushort WORD;
        uchar BYTE;
    } DRB0;

    union {
        ushort WORD;
        uchar BYTE;
    } DRC0;

    union {
        ushort WORD;
        uchar BYTE;
    } DRD0;

    union {
        ushort WORD;
        uchar BYTE;
    } DRA1;

    union {
        ushort WORD;
        uchar BYTE;
    } DRB1;

    union {
        ushort WORD;
        uchar BYTE;
    } DRC1;

    union {
        ushort WORD;
        uchar BYTE;
    } DRD1;

    union {
        uchar BYTE;
        struct {
            uchar ADF     : 1;
            uchar ADIE    : 1;
            uchar ADST    : 1;
            uchar SCAN    : 1;
            uchar CKS     : 1;
            uchar CH      : 3;
        } BIT;
    } CSR0;

    union {
        uchar BYTE;
        struct {
            uchar ADF     : 1;
            uchar ADIE    : 1;
            uchar ADST    : 1;
            uchar SCAN    : 1;
            uchar CKS     : 1;
            uchar CH      : 3;
        } BIT;
    } CSR1;

    union {
        uchar BYTE;
        struct {
            uchar TRGE    : 1;
            uchar         : 7;
        } BIT;
    } CR0;

    union {
        uchar BYTE;
        struct {
            uchar TRGE    : 1;
            uchar         : 7;
        } BIT;
    } CR1;

};

struct _UBC {

    void *UBAR;

    uint UBAMR;

    union {
        ushort WORD;
        struct {
            uchar         : 8;
            uchar CP      : 2;
            uchar ID      : 2;
            uchar RW      : 2;
            uchar SZ      : 2;
        } BIT;
    } UBBR;

};

union _SBYCR {

    uchar BYTE;

    struct {
        uchar SBY     : 1;
        uchar HIZ     : 1;
    } BIT;

};

struct _BSC {

    union {
        ushort WORD;
        struct {
            uchar         : 2;
            uchar MTURWE  : 1;
            uchar         : 4;
            uchar IOE     : 1;
            uchar A3LG    : 1;
            uchar A2LG    : 1;
            uchar A1LG    : 1;
            uchar A0LG    : 1;
            uchar A3SZ    : 1;
            uchar A2SZ    : 1;
            uchar A1SZ    : 1;
            uchar A0SZ    : 1;
        } BIT;
    } BCR1;

    union {
        ushort WORD;
        struct {
            uchar IW3     : 2;
            uchar IW2     : 2;
            uchar IW1     : 2;
            uchar IW0     : 2;
            uchar CW3     : 1;
            uchar CW2     : 1;
            uchar CW1     : 1;
            uchar CW0     : 1;
            uchar SW3     : 1;
            uchar SW2     : 1;
            uchar SW1     : 1;
            uchar SW0     : 1;
        } BIT;
    } BCR2;

    union {
        ushort WORD;
        struct {
            uchar W3      : 4;
            uchar W2      : 4;
            uchar W1      : 4;
            uchar W0      : 4;
        } BIT;
    } WCR1;

    union {
        ushort WORD;
        struct {
            uchar         : 8;
            uchar         : 2;
            uchar DDW     : 2;
            uchar DSW     : 4;
        } BIT;
    } WCR2;

    char WK[2];

    union {
        ushort WORD;
        struct {
            uchar TPC     : 1;
            uchar RCD     : 1;
            uchar TRAS    : 2;
            uchar DWW     : 2;
            uchar DWR     : 2;
            uchar DIW     : 1;
            uchar         : 1;
            uchar BE      : 1;
            uchar RASD    : 1;
            uchar SZ      : 2;
            uchar AMX     : 2;
        } BIT;
    } DCR;

    union {
        ushort WORD;
        struct {
            uchar         : 8;
            uchar         : 1;
            uchar CMF     : 1;
            uchar CMIE    : 1;
            uchar CKS     : 3;
            uchar RFSH    : 1;
            uchar RMD     : 1;
        } BIT;
    } RTCSR;

    ushort RTCNT;

    ushort RTCOR;

};

struct _DMAC {

    union {
        ushort WORD;
        struct {
            ushort         : 6;
            ushort PR      : 2;
            ushort         : 5;
            ushort AE      : 1;
            ushort NMIF    : 1;
            ushort DME     : 1;
        } BIT;
    } DMAOR;

};

struct _DMAC0 {

    void *SAR;

    void *DAR;

    uint DMATCR;

    union {
        uint LONG;
        struct {
            ushort H;
            ushort L;
        } WORD;
        struct {
            ushort         : 13;
            ushort RL      : 1;
            ushort AM      : 1;
            ushort AL      : 1;
            ushort DM      : 2;
            ushort SM      : 2;
            ushort RS      : 4;
            ushort         : 1;
            ushort DS      : 1;
            ushort TM      : 1;
            ushort TS      : 2;
            ushort IE      : 1;
            ushort TE      : 1;
            ushort DE      : 1;
        } BIT;
    } CHCR;

};

struct _DMAC2 {

    void *SAR;

    void *DAR;

    uint DMATCR;

    union {
        uint LONG;
        struct {
            ushort H;
            ushort L;
        } WORD;
        struct {
            ushort         : 12;
            ushort RO      : 1;
            ushort         : 3;
            ushort DM      : 2;
            ushort SM      : 2;
            ushort RS      : 4;
            ushort         : 1;
            ushort DS      : 1;
            ushort TM      : 1;
            ushort TS      : 2;
            ushort IE      : 1;
            ushort TE      : 1;
            ushort DE      : 1;
        } BIT;
    } CHCR;

};

struct _DMAC3 {

    void *SAR;

    void *DAR;

    uint DMATCR;

    union {
        uint LONG;
        struct {
            ushort H;
            ushort L;
        } WORD;
        struct {
            ushort         : 11;
            ushort DI      : 1;
            ushort         : 4;
            ushort DM      : 2;
            ushort SM      : 2;
            ushort RS      : 4;
            ushort         : 1;
            ushort DS      : 1;
            ushort TM      : 1;
            ushort TS      : 2;
            ushort IE      : 1;
            ushort TE      : 1;
            ushort DE      : 1;
        } BIT;
    } CHCR;

};

struct _DTC {

    union {
        uchar BYTE;
        struct {
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } DTEA;

    union {
        uchar BYTE;
        struct {
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } DTEB;

    union {
        uchar BYTE;
        struct {
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } DTEC;

    union {
        uchar BYTE;
        struct {
            uchar B7      : 1;
            uchar B6      : 1;
            uchar B5      : 1;
            uchar B4      : 1;
            uchar B3      : 1;
            uchar B2      : 1;
            uchar B1      : 1;
            uchar B0      : 1;
        } BIT;
    } DTED;

    union {
        uchar BYTE;
        struct {
            uchar B7      : 1;
        } BIT;
    } DTEE;

    char WK;

    union {
        ushort WORD;
        struct {
            uchar         : 5;
            uchar NMIF    : 1;
            uchar AE      : 1;
            uchar SWDTE   : 1;
            uchar DTVEC   : 8;
        } BIT;
    } DTCSR;

    ushort DTBR;

};

union _CCR {

    ushort WORD;

    struct {
        uchar         : 8;
        uchar         : 3;
        uchar CEDRAM  : 1;
        uchar CECS3   : 1;
        uchar CECS2   : 1;
        uchar CECS1   : 1;
        uchar CECS0   : 1;
    } BIT;

};

/* IO߰ıڽ` */

#define vstrct(a, b)    (*(volatile struct a *)b)
#define vunion(a, b)    (*(volatile union a *)b)

#define vuchar(a)       (*(volatile uchar *)a)
#define vulong(a)       (*(volatile ulong *)a)

#define SCI0    vstrct(_SCI,    0xFFFF81A0)
#define SCI1    vstrct(_SCI,    0xFFFF81B0)
#define MTU     vstrct(_MTU,    0xFFFF8240)
#define MTU0    vstrct(_MTU0,   0xFFFF8260)
#define MTU1    vstrct(_MTU1,   0xFFFF8280)
#define MTU2    vstrct(_MTU1,   0xFFFF82A0)
#define MTU3    vstrct(_MTU3,   0xFFFF8200)
#define MTU4    vstrct(_MTU4,   0xFFFF8200)
#define PWM     vstrct(_PWM,    0xFFFF8200)
#define INTC    vstrct(_INTC,   0xFFFF8348)
#define PA      vstrct(_PA,     0xFFFF8380)
#define PB      vstrct(_PB,     0xFFFF8390)
#define PC      vstrct(_PC,     0xFFFF8392)
#define PD      vstrct(_PD,     0xFFFF83A0)
#define PE      vstrct(_PC,     0xFFFF83B0)
#define PF      vstrct(_PF,     0xFFFF83B3)
#define PFC     vstrct(_PFC,    0xFFFF8384)
#define CMT     vstrct(_CMT,    0xFFFF83D0)
#define CMT0    vstrct(_CMT0,   0xFFFF83D2)
#define CMT1    vstrct(_CMT1,   0xFFFF83D8)
#define AD      vstrct(_AD,     0xFFFF83E0)

#define ADA     vstrct(_ADA,    0xFFFF8400)
#define UBC     vstrct(_UBC,    0xFFFF8600)
#define SBYCR   vunion(_SBYCR,  0xFFFF8614)
#define BSC     vstrct(_BSC,    0xFFFF8620)
#define DMAC    vstrct(_DMAC,   0xFFFF86B0)
#define DMAC0   vstrct(_DMAC0,  0xFFFF86C0)
#define DMAC1   vstrct(_DMAC0,  0xFFFF86D0)
#define DMAC2   vstrct(_DMAC2,  0xFFFF86E0)
#define DMAC3   vstrct(_DMAC3,  0xFFFF86F0)
#define DTC     vstrct(_DTC,    0xFFFF8700)
#define CCR     vunion(_CCR,    0xFFFF8740)

#define _MTU2   _MTU1
#define _PE     _PC
#define _CMT1   _CMT0
#define _DMAC1  _DMAC0

#define FPGA_DATA       vulong(0x00800000)

#define FPGA_READ_PC    vuchar(0x0080000b)
#define FPGA_WRIT_PC    vuchar(0x0080000f)
#define FPGA_COMD       vuchar(0x00900003)
#define FPGA_STAT       vuchar(0x00900007)
#define FPGA_HRSO       vuchar(0x00900013)
#define FPGA_HCON       vuchar(0x00900017)
#define FPGA_HPOS       vuchar(0x0090001b)
#define FPGA_VRSO       vuchar(0x00900023)
#define FPGA_VCON       vuchar(0x00900027)
#define FPGA_VPOS       vuchar(0x0090002b)
#define FPGA_RHCO       vuchar(0x00900033)
#define FPGA_RLCO       vuchar(0x00900037)
#define FPGA_GHCO       vuchar(0x00900043)
#define FPGA_GLCO       vuchar(0x00900047)
#define FPGA_BHCO       vuchar(0x00900053)
#define FPGA_BLCO       vuchar(0x00900057)
#define FPGA_COMP       vuchar(0x00900063)
#define FPGA_COP1       vuchar(0x00900067)

#define FPGA_WRD        vuchar(0x00900073)
#define FPGA_RED        vuchar(0x00900077)
#define FPGA_WRC        vuchar(0x0090007b)
#define FPGA_RES        vuchar(0x0090007f)

